// inherit1.cpp : simple inheritance example
//
#include "stdafx.h"
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>

class foo {
    public:    // first we do all  the public interface methods
    // these are used to put values in the private data elements
    void set_a(int x) { a=x;}
    void set_b(int x) { b=x;}

    // these are used to get the values from the private data elements
    int get_a() { return(a);}
    int get_b() { return(b);}

    // these are the constructors
    foo() { a = 0; b = 0;}   // default constructor
    foo(int x) { a=x; b = 0;}
    foo(int x,int y) { a= x; b = y;}

    private:  // these are private data, not visible outside the class
    int a,b;
}; // class foo

// class bar inherits from foo, so we only need to specify the things
// that are unique to bar
class bar : public foo {
   public:
    void set_c(int x) { c=x;}
    int get_c() { return(c);}

    // these are the constructors
    bar() {c = 0;}
    bar(int x) {c=x;}
    // a and b, although inherited by bar, are still private to foo
    bar(int x,int y, int z) { set_a(x); set_b(y); c = z;}
   private:
   int c;
}; // class bar

int 
main(int argc, char **argv)
{
   foo X,Y(6),Z(7,8);
   bar A,B(9),C(1,2,3);

   printf("Starting the program\n");
   printf("X.a = %d X.b = %d\n",X.get_a(),X.get_b());
   printf("Y.a = %d Y.b = %d\n",Y.get_a(),Y.get_b());
   printf("Z.a = %d Z.b = %d\n",Z.get_a(),Z.get_b());

   printf("--------------------------------------------------\n");

   printf("A.a = %d A.b = %d A.c = %d\n",A.get_a(),A.get_b(),A.get_c());
   printf("B.a = %d B.b = %d B.c = %d\n",B.get_a(),B.get_b(),B.get_c());
   printf("C.a = %d C.b = %d C.c = %d\n",C.get_a(),C.get_b(),C.get_c());
   return 0;
/* here is what I get when I run this with g++
X.a = 0 X.b = 0
Y.a = 6 Y.b = 0
Z.a = 7 Z.b = 8
A.a = 0 A.b = 0 A.c = 0
B.a = 0 B.b = 0 B.c = 9
C.a = 1 C.b = 2 C.c = 3
*/
 
/* the following statements are illegal
   remove the comment markers and see what your compiler does
   with them
*/
//    cout << X.get_c() << endl;
//    cout << A.c << endl;

/* here are the errors I get
inh.cc: In function `int main(int, char **)':
inh.cc:67: no matching function for call to `foo::get_c ()'
inh.cc:68: member `c' is a private member of class `bar'
*/
} // main
