// refparam.cpp : some examples of functions with reference parameters
//

#include "stdafx.h"
#include <iostream>
using namespace std;

// call by value function
void 
cbv(int inside_a) { 
   inside_a=7; 
} // cbv

// pass by reference function
void 
pbr(int& inside_a) { 
   inside_a=7; 
} // pbr

int main(int argc, char* argv[])
{
	int outside_a=8; 
	cout << "before: " << outside_a << endl; 
	cbv(outside_a); 
	cout << "after: " << outside_a << endl;

	int outside_b=8; 
	cout << "before: " << outside_b << endl; 
	pbr(outside_b); 
	cout << "after: " << outside_b << endl;

	int normal_a=42;   // just a normal integer variable

	// a reference variable aliases to normal_a
	int & ref_a = normal_a; 

	cout << "normal_a before " << normal_a << endl;
	cout << "ref_a before " << ref_a << endl;

	normal_a = 45;
	cout << "normal_a after normal_a is changed " << normal_a << endl;
	cout << "ref_a after normal_a is changed " << ref_a << endl;
	
	ref_a = 99;
	cout << "normal_a after ref_a is changed " << normal_a << endl;
	cout << "ref_a after ref_a is changed " << ref_a << endl;
	return 0;
}
