// shelves.cpp : Small example of composition
//

#include "stdafx.h"
#include <iostream>
#include <string>
using namespace std;

const int MAXBOOKS = 5;  // maximum load on the shelf

// this represents a single book
class book {
	public:
		void setTitle(string t) { title = t;}
		void setAuthor(string a) { author = a;}
		string getAuthor() { return author;}
		string getTitle() { return title;}
		void print(); // show the title and author
	private:
		string title;  // book title
		string author;  // authors last name
}; // book

// print the books title and suthor
void
book::print()
{
	cout << "Title: " << title << " Author: " << author << endl;
} // print

// this represents a collection of books on a single shelf
// it uses an array to hold the books
class shelf {
	public:
		shelf() { count = 0;}  // constructor
		void addBook(book b);  // put a book on the shelf
		void print();  // print the list of titles on the shelf
		int getCount() { return count;}  // how many are on the shelf
	private:
		book bookshelf[MAXBOOKS];  // place to hold the books
		int count;  // how mant are on the shelf
}; // shelf

// if there is room (the array isn't full), then put the
// book in the next open slot. The count variable contains the
// number of books and also the index of the next slot
void
shelf::addBook(book b)
{
	if(count < MAXBOOKS) // there is room
		bookshelf[count++] = b; // save it and nove the counter
	else
		cout << "No more room" << endl;
} // addBook

// loop over the array and print all the books.
void
shelf::print()
{
		cout << "The books on the shelf are:" << endl;
		// Only loop over the actual books used (count) not the whole array(MAXBOOKS)
		for(int i=0; i < count; i++) { 
			bookshelf[i].print();  // use each books print method
		}
} // addBook

int main(int argc, char* argv[])
{
	shelf shelf1;
	book tome;

	// add a few books to the shelf
	// we can use the same book object over and over
	// because it gets copied when we put it into the array.
	tome.setTitle("The Rockets Shadow");
	tome.setAuthor("Blaine");
	shelf1.addBook(tome);

	tome.setTitle("The Hitchhikers Guide To The Galaxy");
	tome.setAuthor("Adams");
	shelf1.addBook(tome);

	tome.setTitle("Stranger In A Strange Land");
	tome.setAuthor("Heinlein");
	shelf1.addBook(tome);

	tome.setTitle("Thinking Forth");
	tome.setAuthor("Brodie");
	shelf1.addBook(tome);

	cout << "There are " << shelf1.getCount() << " books on the shelf." << endl;
	shelf1.print();
	return 0;
}
