// tempclass.cpp : develop and test a temperature class
//

#include "stdafx.h"
#include <iostream>
using namespace std;

/*  
 *  this class represents a single temperature reading.  
 *  It stores the temp as adouble called t and 
 *  the scale as a single character from the set C,K,F,R 
 *  It provides methods to get at the data and scale, set the values,
 *  print the temp and convert to Celsius
 *  */
class temp {
	public:
		temp() {t = 0.0; scale = 'C';}   // default constructor
		temp(double x) { t = x; scale = 'C'; }  // one arg constructor
		temp(double x, char sc) { t = x; scale = sc; }  // two arg constructor

		// set the temperature and scale
		void setTemp(double v, char sc) { t = v; scale = sc;}

		double getCelsius();  // get the temperature as Celsius

		char getScale() { return scale; }  // fetch the scale
		double getTemp() { return t; }  // fetch the temp

		void printTemp() { cout << t << " Degrees " << showScale();}
	private:
		double t;   // actual temperature reading
		char scale;  // Which scale? Celsius, Kelvin, Fahrenheit, Rankine
		
		// private methods can only be called from other methods in the class
		char * showScale();   // return the scale in English
} ;

// printScale() is part of the class temp so we tell the compiler
// that with the temp:: part. Otherwise, this is just a function definition
// thet returns the string containing the scale name.
char *
temp::showScale()
{
		switch(scale) {
			case 'C' : return "Celsius";
					   break;
			case 'K' : return "Kelvin";
					   break;
			case 'F' : return "Fahrenheit";
					   break;
			case 'R' : return "Rankine";
					   break;
		} // esac
		return "bogus";  // bad scale letter
} // showScale

// This is a public method as listed in the class definition
// this converts the temperature (if needed) to Celsius
// and returns it
double
temp::getCelsius()
{
		if(scale == 'C') return t;  // Celsius->Celsius 
		if(scale == 'K') return t - 273.15; // Kelvin->Celsius
		if(scale == 'F') return ((t - 32.0) * 5.0)/9.0; // Fahrenheit->Celsius
		if(scale == 'R') return t * (5.0/9.0)-273.15; // Rankine->Celsius
		return 0.0;  // bad scale letter
} // getCelsius

int 
main(int argc, char* argv[])
{
	temp ktemp,rtemp;   // no constructor
	temp ctemp(100.0);  // one arg constructor
	temp ftemp(212.0,'F');  // two arg constructor
	temp rcopy1, rcopy2;   // hold copies of the Rankine temp

	ktemp.setTemp(0.0,'K'); // use public method to set temp and scale
	ktemp.printTemp();
	cout << " in Celcius is " << ktemp.getCelsius() << endl << endl;;

	ctemp.printTemp();
	cout << " in Celcius is " << ctemp.getCelsius() << endl << endl;;

	ftemp.printTemp();
	cout << " in Celcius is " << ftemp.getCelsius() << endl << endl;;

	rtemp.setTemp(671.4,'R');
	rtemp.printTemp();
	cout << " in Celcius is " << rtemp.getCelsius() << endl << endl;;

	// first try copying by assignment
	rcopy1 = rtemp;
	cout << "assignment copy" << endl;
	rcopy1.printTemp();
	cout << " in Celcius is " << rcopy1.getCelsius() << endl << endl;;
	
	// now copy by methods
	rcopy2.setTemp(rtemp.getTemp(),rtemp.getScale());
	cout << "method copy" << endl;
	rcopy2.printTemp();
	cout << " in Celcius is " << rcopy2.getCelsius() << endl;
	return 0;
}
